"use strict";
this.name        = "Here be Dragons"; 
this.author      = "Stranger."; 
this.copyright   = "Stranger.";
this.licence     = "CC BY-NC-SA 3.0"; 
this.description = "Worldscript to block info for unvisited systems."; 
this.version     = "1.0";

this.startUpComplete = function()   // set map after System Makeup processed planet textures!
    {
    this.$explorerClub_data = JSON.parse(missionVariables.explorerClub_record);
    this.$setupSystemDisplay();
    this.$setupLocalDisplay();
    }

    this.shipLaunchedFromStation = this.shipExitedWitchspace = this.shipDockedWithStation = function()
    {
    if (system.isInterstellarSpace) return;
    this.$setupSystemDisplay();
    this.$setupLocalDisplay();
    }

this.playerStartedJumpCountdown = function()
    {
    var g = system.info.galaxyID;    
    var t = player.ship.targetSystem;
    for (var i = 0; i < 256; i++)
        {
        System.infoForSystem(g, i).setProperty(2, "concealment", 200);      // temporary show all systems for New Cargoes
        }
    System.infoForSystem(g, system.ID).setProperty(2, "concealment", 0);    // restore complete data set for system of departure...
    System.infoForSystem(g, t).setProperty(2, "concealment", 0);            // ... and system of destination
    }

this.playerCancelledJumpCountdown = this.playerJumpFailed = function()
    {
    if (system.isInterstellarSpace) return;
    this.$setupSystemDisplay();
    this.$setupLocalDisplay();    
    }

this.guiScreenChanged = function(to,from)
    {
    if (guiScreen === "GUI_SCREEN_SYSTEM_DATA")
        {
        if (system.isInterstellarSpace) return;
        var g = system.info.galaxyID;
        var t = player.ship.targetSystem;
        if (system.ID == t) return;
        var target_range = System.infoForSystem(g, system.ID).distanceToSystem(System.infoForSystem(g, t));
        if ((this.$explorerClub_data[g].indexOf(t) === -1) && (target_range > 7))
            {
            mission.runScreen({title: "Access failed", message: "Commander,\n\nThis is unexplored section of Ooniverse!\n\nLocal database can't provide you reliable information for this system.\n\nVisit it at your own risk.", background: "Explorers_Club.png"});
            }
        }
    }

this.$setupSystemDisplay = function()
    {
    var g = system.info.galaxyID;
    for (var i = 0; i < 256; i++)
        {
        if (this.$explorerClub_data[g].indexOf(i) != -1)
            {
            System.infoForSystem(g, i).setProperty(2, "concealment", 0);
            }
        else
            {
            if (player.ship.docked != true)
                {
                System.infoForSystem(g, i).setProperty(2, "concealment", 300);
                }
            else
                {
                System.infoForSystem(g, i).setProperty(2, "concealment", 200);
                }            
            }
        }    
    }

this.$setupLocalDisplay = function()
    {
    var g = system.info.galaxyID;
    var l = System.infoForSystem(g, system.ID).systemsInRange();
    for (var j = 0; j < l.length; j++)
        {
        var m = l[j].systemID;
        System.infoForSystem(g, m).setProperty(2, "concealment", 0);
        }
    System.infoForSystem(g, system.ID).setProperty(2, "concealment", 0);
    }
